/**
 * 构建工作流
 */

const { getExtendConfigScript, getMode, getProjectRoot } = require('./common/util.js')

module.exports = ({ webpackConfig }) => {
  const projectRoot = getProjectRoot()

  // 扩展配置
  const extendConfigScript = getExtendConfigScript(projectRoot)

  extendConfigScript && extendConfigScript({
    mode: getMode(),
    webpackConfig
  })

  // webpack
  require('webpack')(webpackConfig.toConfig(), (err, stats) => {
    if (err) {
      console.error(err)
      return
    }

    console.log(stats.toString({
      chunks: false,
      colors: true
    }))
  })
}
