/**
 * 工具函数
 */

const path = require('path')
const fs = require('fs')

process.env.mode = 'production'
process.env.projectRoot = process.cwd()

/**
 * 设置缓存 mode
 */
const setMode = mode => (process.env.mode = mode)
exports.setMode = setMode

/**
 * 获取缓存 mode
 */
const getMode = () => process.env.mode
exports.getMode = getMode

/**
 * 获取项目根目录
 */
const getProjectRoot = () => process.env.projectRoot
exports.getProjectRoot = getProjectRoot

/**
 * 获取扩展配置脚本
 */
exports.getExtendConfigScript = projectRoot => {
  const extendConfigScript = path.resolve(projectRoot, 'legoflow.js')

  return fs.existsSync(extendConfigScript) ? require(extendConfigScript) : void 0
}

/**
 * 获取是否带 sourceMap
 */
exports.isWithSourceMap = () => getMode() === 'development'

/**
 * 获取是否带 hash
 */
exports.isWithHash = () => getMode() === 'development' ? '' : '.[hash]'
