/**
 * 开发工作流
 */

const { getExtendConfigScript, getMode, getProjectRoot } = require('./common/util.js')

module.exports = ({ webpackConfig }) => {
  const projectRoot = getProjectRoot()

  // dev server 配置
  const webpackDevServerConfig = {
    host: '0.0.0.0',
    contentBase: './public',
    hot: true,
    historyApiFallback: false,
    compress: false,
    noInfo: false,
    lazy: false,
    quiet: false,
    stats: {
      colors: true,
      modules: false,
      children: false,
      chunks: false,
      chunkModules: false
    },
    filename: 'bundle.js',
    watchOptions: {
      aggregateTimeout: 100,
      poll: 1000
    },
    proxy: {},
    disableHostCheck: true,
    https: false
  }

  // 扩展配置
  const extendConfigScript = getExtendConfigScript(projectRoot)

  extendConfigScript && extendConfigScript({
    mode: getMode(),
    webpackConfig,
    webpackDevServerConfig
  })

  // webpack
  const compiler = require('webpack')(webpackConfig.toConfig())

  // webpack dev server
  const WebpackDevServer = require('webpack-dev-server')
  new WebpackDevServer(compiler, webpackDevServerConfig).listen('8080', '0.0.0.0')
}
